var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Event } from "../../Event";
import { TypedEvent } from '../../TypedEvent';
import { nameof } from "ts-simple-nameof";
import { Api } from "../../Api";
import { ExalusConnectionService } from '../ExalusConnectionService';
import { SessionService } from '../Session/SessionService';
import { DataFrame, Method, Status } from "../../DataFrame";
import { LocalStorageService } from "../LocalStorageService";
var ControllerConfigurationService = (function () {
    function ControllerConfigurationService() {
        var _this = this;
        this._connection = null;
        this._session = null;
        this._localStorage = null;
        this._serviceName = nameof(ControllerConfigurationService);
        this._onEnteredConfigurationEvent = new Event();
        this._onExitedConfigurationEvent = new Event();
        this._onConfigurationTimeCheckedEvent = new TypedEvent();
        this._configurationTime = new Date();
        this._appEnteredConfigurationMode = false;
        this._connection = Api.Get(ExalusConnectionService);
        this._session = Api.Get(SessionService);
        this._localStorage = Api.Get(LocalStorageService);
        this._connection.OnDataReceivedEvent().Subscribe(function (data) {
            if (data.Resource == "/info/configuration/mode/entry") {
                if (!_this._appEnteredConfigurationMode)
                    _this._onEnteredConfigurationEvent.Invoke();
            }
            else if (data.Resource == "/info/configuration/mode/exit") {
                if (!_this._appEnteredConfigurationMode)
                    _this._onExitedConfigurationEvent.Invoke();
            }
        });
    }
    ControllerConfigurationService.prototype.GetServiceName = function () {
        return this._serviceName;
    };
    ControllerConfigurationService.prototype.GetLastKnownConfigurationChangeTime = function () {
        var _a;
        var result = (_a = this._localStorage) === null || _a === void 0 ? void 0 : _a.Read(ControllerConfigurationService, "last_configuration_time");
        if (result != null)
            return new Date(result);
        else
            return new Date();
    };
    ControllerConfigurationService.prototype.SaveLastConfigurationChangeTime = function (time) {
        var _a;
        (_a = this._localStorage) === null || _a === void 0 ? void 0 : _a.Save(ControllerConfigurationService, "last_configuration_time", time.toString());
    };
    ControllerConfigurationService.prototype.EnterConfigurationModeAsync = function () {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this._appEnteredConfigurationMode = true;
                        return [4, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new EntryConfigurationModeRequest(), 5000, false))];
                    case 1:
                        _b.sent();
                        return [2];
                }
            });
        });
    };
    ControllerConfigurationService.prototype.ExitConfigurationModeAsync = function () {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new ExitConfigurationModeRequest(), 5000, false))];
                    case 1:
                        _b.sent();
                        this._appEnteredConfigurationMode = false;
                        return [2];
                }
            });
        });
    };
    ControllerConfigurationService.prototype.OnEnteredConfigurationEvent = function () {
        return this._onEnteredConfigurationEvent;
    };
    ControllerConfigurationService.prototype.OnExitedConfigurationEvent = function () {
        return this._onExitedConfigurationEvent;
    };
    ControllerConfigurationService.prototype.OnConfigurationTimeCheckedEvent = function () {
        return this._onConfigurationTimeCheckedEvent;
    };
    ControllerConfigurationService.prototype.GetLastConfigurationChangeTimeAsync = function () {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new LastChangeTimeRequest(), 5000, false))];
                    case 1:
                        result = _b.sent();
                        if (result == null || (result === null || result === void 0 ? void 0 : result.Status) != Status.OK)
                            throw new Error("Failed to get last configuration change time");
                        this._configurationTime = new Date(result.Data);
                        return [2, this._configurationTime];
                }
            });
        });
    };
    ControllerConfigurationService.prototype.CheckIfConfigurationHasChangedAsync = function () {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.GetLastConfigurationChangeTimeAsync()];
                    case 1:
                        result = _a.sent();
                        if (this.GetLastKnownConfigurationChangeTime().toString() != result.toString()) {
                            this.SaveLastConfigurationChangeTime(result);
                            this._onConfigurationTimeCheckedEvent.Invoke(result);
                            return [2, true];
                        }
                        else
                            return [2, false];
                        return [2];
                }
            });
        });
    };
    return ControllerConfigurationService;
}());
export { ControllerConfigurationService };
var EntryConfigurationModeRequest = (function (_super) {
    __extends(EntryConfigurationModeRequest, _super);
    function EntryConfigurationModeRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/system/configuration/mode/entry";
        _this.Method = Method.Put;
        return _this;
    }
    return EntryConfigurationModeRequest;
}(DataFrame));
var ExitConfigurationModeRequest = (function (_super) {
    __extends(ExitConfigurationModeRequest, _super);
    function ExitConfigurationModeRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/system/configuration/mode/exit";
        _this.Method = Method.Put;
        return _this;
    }
    return ExitConfigurationModeRequest;
}(DataFrame));
var LastChangeTimeRequest = (function (_super) {
    __extends(LastChangeTimeRequest, _super);
    function LastChangeTimeRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/system/configuration/change/time";
        _this.Method = Method.Get;
        return _this;
    }
    return LastChangeTimeRequest;
}(DataFrame));
//# sourceMappingURL=ControllerConfigurationService.js.map