var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Api } from '../../Api';
import { DataFrame, Method, Status } from '../../DataFrame';
import { TypedEvent } from '../../TypedEvent';
import { ExalusConnectionService } from '../ExalusConnectionService';
import { FieldChangeResult, FieldChangeResultType } from '../FieldChangeResult';
import { DevicesService } from './DevicesService';
import { CommunicationWay, DeviceState, DeviceType } from './IDevice';
var Device = (function () {
    function Device() {
        var _this = this;
        this._onDeviceStateChangedEvent = new TypedEvent();
        this._onDeviceTasksExecutionChangedOnChannelsEvent = new TypedEvent();
        this._serialNumber = null;
        this._model = null;
        this._modelGuid = null;
        this._manufacturerGuid = null;
        this._isVirtual = false;
        this._isEnabled = false;
        this._deviceState = DeviceState.Working;
        this._deviceType = DeviceType.Unknown;
        this._communicationWay = CommunicationWay.OneWay;
        this._availableTasksTypes = [];
        this._availableResponseTypes = [];
        this._channels = [];
        var devicesApi = Api.Get(DevicesService);
        var stateChangedEvent = this._onDeviceStateChangedEvent;
        var tasksExecutionChangeEvent = this._onDeviceTasksExecutionChangedOnChannelsEvent;
        devicesApi.OnDeviceStateChangedEvent().Subscribe(function (stateChange) {
            if (stateChange[0].Guid != _this._guid)
                return;
            stateChangedEvent.Invoke(stateChange[1]);
        });
        devicesApi.OnDevicesTasksExecutionChangeEvent().Subscribe(function (tasks) {
            tasksExecutionChangeEvent.Invoke(tasks.filter(function (task) { return task.DeviceGuid == _this._guid; }).map(function (task) { return task.Channel; }));
        });
    }
    Device.prototype.RemoveDeviceAsync = function () {
        return Api.Get(DevicesService).RemoveDeviceAsync(this);
    };
    Device.prototype.ExecuteDeviceTaskAsync = function (task) {
        return Api.Get(DevicesService).ExecuteDeviceTaskAsync(this, task);
    };
    Device.prototype.OnDeviceTasksExecutionChangedOnChannelsEvent = function () {
        return this._onDeviceTasksExecutionChangedOnChannelsEvent;
    };
    Device.prototype.OnDeviceStateChangedEvent = function () {
        return this._onDeviceStateChangedEvent;
    };
    Object.defineProperty(Device.prototype, "Guid", {
        get: function () {
            return this._guid == null ? "" : this._guid;
        },
        set: function (guid) {
            this._guid = guid;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "Name", {
        get: function () {
            return this._name == null ? "" : this._name;
        },
        set: function (name) {
            this._name = name;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "ChannelsAmount", {
        get: function () {
            return this._channelsAmount == null ? 0 : this._channelsAmount;
        },
        set: function (amount) {
            this._channelsAmount = amount;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "SerialNumber", {
        get: function () {
            return this._serialNumber;
        },
        set: function (serialNumber) {
            this._serialNumber = serialNumber;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "Model", {
        get: function () {
            return this._model;
        },
        set: function (model) {
            this._model = model;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "ModelGuid", {
        get: function () {
            return this._modelGuid;
        },
        set: function (model) {
            this._modelGuid = model;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "ManufacturerGuid", {
        get: function () {
            return this._manufacturerGuid;
        },
        set: function (manufacturerGuid) {
            this._manufacturerGuid = manufacturerGuid;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "IsVirtual", {
        get: function () {
            return this._isVirtual;
        },
        set: function (isVirtual) {
            this._isVirtual = isVirtual;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "IsEnabled", {
        get: function () {
            return this._isEnabled;
        },
        set: function (isEnabled) {
            this._isEnabled = isEnabled;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "DeviceState", {
        get: function () {
            return this._deviceState;
        },
        set: function (deviceState) {
            this._deviceState = deviceState;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "DeviceType", {
        get: function () {
            return this._deviceType;
        },
        set: function (deviceType) {
            this._deviceType = deviceType;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "CommunicationWay", {
        get: function () {
            return this._communicationWay;
        },
        set: function (communicationWay) {
            this._communicationWay = communicationWay;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "AvailableTaskTypes", {
        get: function () {
            return this._availableTasksTypes;
        },
        set: function (availableTasksTypes) {
            this._availableTasksTypes = availableTasksTypes;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "AvailableResponseTypes", {
        get: function () {
            return this._availableResponseTypes;
        },
        set: function (availableResponseTypes) {
            this._availableResponseTypes = availableResponseTypes;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "Channels", {
        get: function () {
            return this._channels;
        },
        enumerable: false,
        configurable: true
    });
    Device.prototype.ChangeDeviceNameAsync = function (name) {
        return __awaiter(this, void 0, void 0, function () {
            var result, ex_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4, Api.Get(ExalusConnectionService)
                                .SendAndWaitForResponseAsync(new DeviceChannelConfigurationRequest(this, name), 5000, false)];
                    case 1:
                        result = _a.sent();
                        switch (result.Status) {
                            case Status.OK:
                                return [2, new FieldChangeResult(FieldChangeResultType.Changed, "")];
                            case Status.WrongData:
                                if (result.Data == "DeviceNotFound")
                                    return [2, new FieldChangeResult(FieldChangeResultType.Failed, "DeviceNotFound")];
                                break;
                            case Status.NoPermissionsToCallGivenResource:
                                return [2, new FieldChangeResult(FieldChangeResultType.NoPermissions, "")];
                        }
                        return [3, 3];
                    case 2:
                        ex_1 = _a.sent();
                        if (ex_1.message.includes("timeout"))
                            return [2, new FieldChangeResult(FieldChangeResultType.ControllerResponseTimeout, "")];
                        return [2, new FieldChangeResult(FieldChangeResultType.UnknownError, "")];
                    case 3: return [2, new FieldChangeResult(FieldChangeResultType.Unknown, "")];
                }
            });
        });
    };
    Device.prototype.ExecuteTaskAsync = function (task) {
        return Api.Get(DevicesService).ExecuteDeviceTaskAsync(this, task);
    };
    return Device;
}());
export { Device };
var DeviceChannelConfigurationRequest = (function (_super) {
    __extends(DeviceChannelConfigurationRequest, _super);
    function DeviceChannelConfigurationRequest(device, name) {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/device/name";
        _this.Method = Method.Put;
        var data = new DeviceNameData();
        data.DeviceGuid = device.Guid;
        data.Name = name;
        _this.Data = data;
        return _this;
    }
    return DeviceChannelConfigurationRequest;
}(DataFrame));
var DeviceNameData = (function () {
    function DeviceNameData() {
        this.DeviceGuid = "";
        this.Name = "";
    }
    return DeviceNameData;
}());
//# sourceMappingURL=Device.js.map