var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Api } from "../../Api";
import { TypedEvent } from "../../TypedEvent";
import { FieldChangeResultType, FieldChangeResult } from "../FieldChangeResult";
import { DevicesService } from "./DevicesService";
import { ChannelConfigurations } from "./IDeviceChannel";
import { DeviceTaskExecutionResult } from "./TaskExecutionResult";
import { ExalusConnectionService } from "../ExalusConnectionService";
import { DataFrame, Method, Status } from "../../DataFrame";
import { DependencyContainer } from '../../DependencyContainer';
var DeviceChannel = (function () {
    function DeviceChannel() {
        this._device = null;
        this._number = 0;
        this._name = "";
        this._iconName = "";
        this._states = [];
        this._mode = ChannelConfigurations.Default;
        this._channelGroups = [];
        this._isHidden = false;
        this._availableTasksTypes = [];
        this._availableResponseTypes = [];
        this._onTasksExecutionChangedEvent = new TypedEvent();
    }
    DeviceChannel.prototype.SetDevice = function (device) {
        var _this = this;
        this._device = device;
        this._device.OnDeviceStateChangedEvent().Subscribe(function (newState) {
            var channel = newState.Data.Channel;
            if (channel != _this._number)
                return;
            _this._states = _this._states.where(function (state) { return state.TypeAsEnum != newState.TypeAsEnum; }).toArray();
            _this._states.push(newState);
        });
    };
    DeviceChannel.prototype.GetChannelConfigurationData = function () {
        var data = new ChannelConfigurationData();
        data.Channel = this._number;
        data.ChannelName = this._name;
        data.Configuration = this._mode;
        data.GroupsGuids = this._channelGroups;
        data.Hidden = this._isHidden;
        data.IconName = this._iconName;
        return data;
    };
    DeviceChannel.prototype.HideAsync = function () {
        var data = this.GetChannelConfigurationData();
        data.Hidden = true;
        return this.ChangeConfigurationAsync(data);
    };
    DeviceChannel.prototype.ShowAsync = function () {
        var data = this.GetChannelConfigurationData();
        data.Hidden = false;
        return this.ChangeConfigurationAsync(data);
    };
    DeviceChannel.prototype.ChangeNameAsync = function (name) {
        var data = this.GetChannelConfigurationData();
        data.ChannelName = name;
        return this.ChangeConfigurationAsync(data);
    };
    DeviceChannel.prototype.ChangeIconNameAsync = function (name) {
        var data = this.GetChannelConfigurationData();
        data.IconName = name;
        return this.ChangeConfigurationAsync(data);
    };
    DeviceChannel.prototype.ChangeGroupsAsync = function (groups) {
        var data = this.GetChannelConfigurationData();
        data.GroupsGuids = groups;
        return this.ChangeConfigurationAsync(data);
    };
    DeviceChannel.prototype.ChangeConfigurationAsync = function (configuration) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var result, ex_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 2, , 3]);
                        return [4, Api.Get(ExalusConnectionService)
                                .SendAndWaitForResponseAsync(new DeviceChannelConfigurationRequest(configuration), 5000, false)];
                    case 1:
                        result = _b.sent();
                        switch (result.Status) {
                            case Status.OK:
                                return [2, new FieldChangeResult(FieldChangeResultType.Changed, "")];
                            case Status.WrongData:
                                switch (result.Data) {
                                    case "DeviceNotFound":
                                        (_a = DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Error("Failed to change channel configuration, referenced device does not exist!");
                                        return [2, new FieldChangeResult(FieldChangeResultType.WrongData, "DeviceNotFound")];
                                }
                                break;
                            case Status.FatalError:
                                return [2, new FieldChangeResult(FieldChangeResultType.UnknownError, "")];
                        }
                        return [3, 3];
                    case 2:
                        ex_1 = _b.sent();
                        if (ex_1.message.includes("timeout"))
                            return [2, new FieldChangeResult(FieldChangeResultType.ControllerResponseTimeout, "")];
                        return [3, 3];
                    case 3: return [2, new FieldChangeResult(FieldChangeResultType.Unknown, "")];
                }
            });
        });
    };
    Object.defineProperty(DeviceChannel.prototype, "Number", {
        get: function () {
            return this._number;
        },
        set: function (value) {
            this._number = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceChannel.prototype, "Name", {
        get: function () {
            return this._name;
        },
        set: function (value) {
            this._name = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceChannel.prototype, "IconName", {
        get: function () {
            return this._iconName;
        },
        set: function (value) {
            this._iconName = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceChannel.prototype, "States", {
        get: function () {
            return this._states;
        },
        set: function (value) {
            this._states = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceChannel.prototype, "State", {
        set: function (value) {
            throw new Error("Method not implemented.");
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceChannel.prototype, "Mode", {
        get: function () {
            return this._mode;
        },
        set: function (value) {
            this._mode = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceChannel.prototype, "ChannelGroups", {
        get: function () {
            return this._channelGroups;
        },
        set: function (value) {
            this._channelGroups = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceChannel.prototype, "IsHidden", {
        get: function () {
            return this._isHidden;
        },
        set: function (value) {
            this._isHidden = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceChannel.prototype, "AvailableTaskTypes", {
        get: function () {
            return this._availableTasksTypes;
        },
        set: function (value) {
            this._availableTasksTypes = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceChannel.prototype, "AvailableResponseTypes", {
        get: function () {
            return this._availableResponseTypes;
        },
        set: function (value) {
            this._availableResponseTypes = value;
        },
        enumerable: false,
        configurable: true
    });
    DeviceChannel.prototype.OnTasksExecutionChangeEvent = function () {
        return this._onTasksExecutionChangedEvent;
    };
    DeviceChannel.prototype.ExecuteTaskAsync = function (task) {
        if (this._device != null)
            return Api.Get(DevicesService).ExecuteDeviceTaskAsync(this._device, task);
        else
            return Promise.resolve(DeviceTaskExecutionResult.Failed);
    };
    return DeviceChannel;
}());
export { DeviceChannel };
var ChannelConfigurationData = (function () {
    function ChannelConfigurationData() {
        this.Channel = 0;
        this.ChannelName = "";
        this.Configuration = ChannelConfigurations.Default;
        this.GroupsGuids = [];
        this.IconName = "";
        this.Hidden = false;
    }
    return ChannelConfigurationData;
}());
export { ChannelConfigurationData };
var DeviceChannelConfigurationRequest = (function (_super) {
    __extends(DeviceChannelConfigurationRequest, _super);
    function DeviceChannelConfigurationRequest(configuration) {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/device/channel/configuration";
        _this.Method = Method.Put;
        _this.Data = configuration;
        return _this;
    }
    return DeviceChannelConfigurationRequest;
}(DataFrame));
//# sourceMappingURL=DeviceChannel.js.map