var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { nameof } from 'ts-simple-nameof';
import { TypedEvent } from '../../TypedEvent';
import { DeviceState, CommunicationWay, DeviceType, DeviceTaskTypeInfo, DeviceResponseTypeInfo, DeviceTasksInfo } from './IDevice';
import { BatteryDeviceState, BinarySensorStateDeviceState, BlindCalibrationDeviceState, BlindOpenCloseTimeDeviceState, BlindPositionDeviceState, BlindRemoteButtonDeviceState, ChannelOnOffDeviceState, ConfigurationDeviceState, CurrentLightThresholdDeviceState, CurrentWindThresholdDeviceState, DoorBellDeviceState, FacadePositionDeviceState, FacadeRemoteButtonDeviceState, GatePositionDeviceState, GatewayPositionDeviceState, HumiditySensorDeviceState, LightBrightnessDeviceState, LightColorDeviceState, LightWarmthDeviceState, MeasuredBrightnessDeviceState, MeasuredDistanceDeviceState, MeasuredEnergyDeviceState, MeasuredTemperatureDeviceState, MovementSensorDeviceState, OvercurrentProtectionDeviceState, OvercurrentProtectionThresholdDeviceState, ReedPositionDeviceState, RemoteButtonDeviceState, SignalStrenghtDeviceState, StateReliability, VibrationSensorDeviceState, WindSpeedDeviceState } from './IDeviceState';
import { DeviceChannel } from './DeviceChannel';
import { ChannelConfigurations, TaskExecution } from './IDeviceChannel';
import { Api } from '../../Api';
import { ExalusConnectionService } from '../ExalusConnectionService';
import { DependencyContainer } from '../../DependencyContainer';
import { DataFrame, Status, Method } from '../../DataFrame';
import { Device } from './Device';
import { ConnectionState } from '../IExalusConnectionService';
import { DeviceControlFeature } from './IDeviceTask';
import { BlindActionEnum, FacadeActionEnum } from './Tasks/Tasks';
import { DeviceTaskExecutionResult } from './TaskExecutionResult';
var DevicesService = (function () {
    function DevicesService() {
        var _this = this;
        this._devices = [];
        this._serviceName = nameof(DevicesService);
        this._onDevicesTasksChangedEvent = new TypedEvent();
        this._onDeviceFoundEvent = new TypedEvent();
        this._onDeviceRegisteredEvent = new TypedEvent();
        this._onDeviceRemovedEvent = new TypedEvent();
        this._onDeviceStateChangedEvent = new TypedEvent();
        this._connection = null;
        this._fastStatesSync = false;
        this._connection = Api.Get(ExalusConnectionService);
        this._connection.OnConnectionStateChangedEvent().Subscribe(function (state) { return __awaiter(_this, void 0, void 0, function () {
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = state;
                        switch (_a) {
                            case ConnectionState.Connected: return [3, 1];
                        }
                        return [3, 3];
                    case 1:
                        _b = this;
                        return [4, this.GetDevicesAsync()];
                    case 2:
                        _b._devices = _c.sent();
                        return [3, 3];
                    case 3: return [2];
                }
            });
        }); });
        this._connection.OnDataReceivedEvent().Subscribe(function (frame) {
            if (frame.Resource === "/info/devices/tasks") {
                _this.ParseDeviceTaskInfo(frame.Data);
            }
            else if (frame.Resource === "/devices/blinds/times") {
            }
            else if (frame.Resource === "/info/devices/device/found") {
                var foundDevices = _this.MapApiDevices(frame.Data);
                foundDevices.forEach(function (device) {
                    var _a;
                    (_a = DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Debug("Found device: ".concat(device.Name, " guid: ").concat(device.Guid));
                    _this._onDeviceFoundEvent.Invoke(device);
                });
            }
            else if (frame.Resource === "/info/devices/device/state/changed") {
                var state_1 = frame.Data;
                var devices = _this._devices.filter(function (a) { return a.Guid == state_1.DeviceGuid; });
                if (devices.length > 0) {
                    var device = devices[0];
                    var st = _this.MapApiDeviceStateToDeviceState(device, state_1);
                    if (st != null) {
                        _this._onDeviceStateChangedEvent
                            .Invoke([device, st]);
                    }
                }
            }
            else if (frame.Resource === "/info/devices/device/registered") {
                var registeredDevices = _this.MapApiDevices(frame.Data);
                registeredDevices.forEach(function (device) {
                    var _a;
                    (_a = DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Debug("Registered device: ".concat(device.Name, " guid: ").concat(device.Guid));
                    _this._onDeviceRegisteredEvent.Invoke(device);
                });
            }
            else if (frame.Resource === "/info/devices/device/removed") {
                var removedDevices = _this.MapApiDevices(frame.Data);
                removedDevices.forEach(function (device) {
                    var _a;
                    (_a = DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Debug("Removed device: ".concat(device.Name, " guid: ").concat(device.Guid));
                    _this._onDeviceRemovedEvent.Invoke(device);
                });
            }
        });
    }
    DevicesService.prototype.GetCurrentlyRunningTaksAsync = function () {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new GetRunningDevicesTasksRequest(), 15000, false))];
                    case 1:
                        result = _b.sent();
                        if ((result === null || result === void 0 ? void 0 : result.Status) == Status.OK && result.Data != null) {
                            this.ParseDeviceTaskInfo(result.Data);
                        }
                        return [2];
                }
            });
        });
    };
    DevicesService.prototype.ParseDeviceTaskInfo = function (tasks) {
        var devicesTasks = [];
        tasks.forEach(function (taskChannelPair) {
            var pair = taskChannelPair.split(";");
            var task = new DeviceTasksInfo();
            task.DeviceGuid = pair[0];
            task.Channel = Number(pair[1]);
            task.Status = TaskExecution.ExecutingTasks;
            devicesTasks.push(task);
        });
        this._onDevicesTasksChangedEvent.Invoke(devicesTasks);
    };
    DevicesService.prototype.MapApiDeviceStateToDeviceState = function (device, state) {
        var _a;
        var st = state.state;
        switch (state.DataType) {
            case "ChannelOnOff":
                return new ChannelOnOffDeviceState(state);
            case "DoorBell":
                return new DoorBellDeviceState(state);
            case "ReedPosition":
                return new ReedPositionDeviceState(state);
            case "BlindPosition":
                return new BlindPositionDeviceState(state);
            case "ButtonState":
                return new RemoteButtonDeviceState(state);
            case "LightColor":
                return new LightColorDeviceState(state);
            case "LightTemperature":
                return new LightWarmthDeviceState(state);
            case "LightBrightness":
                return new LightBrightnessDeviceState(state);
            case "TemperatureSensor":
            case "TemperatureState":
            case "MeasuredTemperature":
                return new MeasuredTemperatureDeviceState(state);
            case "BatteryState":
                return new BatteryDeviceState(state);
            case "MeasuredBrightness":
            case "DeviceBrightnessState":
                return new MeasuredBrightnessDeviceState(state);
            case "EnergyMeasuredPower":
                break;
            case "EnergyMeasuredCurrent":
                break;
            case "EnergyMeasuredVoltage":
                break;
            case "Energy":
                return new MeasuredEnergyDeviceState(state);
            case "DistanceSensor":
                return new MeasuredDistanceDeviceState(state);
            case "MovementSensor":
                return new MovementSensorDeviceState(state);
            case "BlindsControlButton":
                return new BlindRemoteButtonDeviceState(state);
            case "FacadeControlButton":
                return new FacadeRemoteButtonDeviceState(state);
            case "SignalStrength":
                return new SignalStrenghtDeviceState(state);
            case "GatePosition":
                return new GatePositionDeviceState(state);
            case "GatewayPosition":
                return new GatewayPositionDeviceState(state);
            case "IBlindCalibrationStatus":
            case "BlindCalibration":
                return new BlindCalibrationDeviceState(state);
            case "HumiditySensor":
                return new HumiditySensorDeviceState(state);
            case "VibrationSensor":
                return new VibrationSensorDeviceState(state);
            case "DigitalInputSensor":
                return new BinarySensorStateDeviceState(state);
            case "ConfigurationState":
                return new ConfigurationDeviceState(state);
            case "BlindOpenCloseTime":
            case "IBlindOpenCloseTime":
                return new BlindOpenCloseTimeDeviceState(state);
            case "IOvercurrentProtection":
            case "OvercurrentProtection":
                return new OvercurrentProtectionDeviceState(state);
            case "IOvercurrentProtectionThreshold":
            case "OvercurrentProtectionThreshold":
                return new OvercurrentProtectionThresholdDeviceState(state);
            case "FacadePosition":
            case "FacadeState":
                return new FacadePositionDeviceState(state);
            case "CurrentWindThreshold":
                return new CurrentWindThresholdDeviceState(state);
            case "CurrentLightThreshold":
                return new CurrentLightThresholdDeviceState(state);
            case "WindSpeed":
                return new WindSpeedDeviceState(state);
            default:
                (_a = DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Debug("Not supported device state ".concat(state.DataType));
                break;
        }
        return null;
    };
    DevicesService.prototype.GetServiceName = function () {
        return this._serviceName;
    };
    DevicesService.prototype.SyncDevicesStatesAsync = function () {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!this._fastStatesSync) return [3, 2];
                        return [4, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new SyncDevicesStatesRequest(), 15000, false))];
                    case 1:
                        result = _b.sent();
                        return [2, (result === null || result === void 0 ? void 0 : result.Status) == Status.OK];
                    case 2: throw new Error('Precise, slow states synchronization is not implemented yet');
                }
            });
        });
    };
    DevicesService.prototype.OnDevicesTasksExecutionChangeEvent = function () {
        return this._onDevicesTasksChangedEvent;
    };
    DevicesService.prototype.OnDeviceStateChangedEvent = function () {
        return this._onDeviceStateChangedEvent;
    };
    DevicesService.prototype.OnDeviceRegisteredEvent = function () {
        return this._onDeviceRegisteredEvent;
    };
    DevicesService.prototype.OnDeviceRemovedEvent = function () {
        return this._onDeviceRemovedEvent;
    };
    DevicesService.prototype.OnDeviceFoundEvent = function () {
        return this._onDeviceFoundEvent;
    };
    DevicesService.prototype.MapApiDevices = function (devicesObjects) {
        var devices = [];
        if (devicesObjects == null)
            return [];
        devicesObjects.forEach(function (element) {
            var _a, _b, _c, _d;
            var device = new Device();
            device.Guid = element.Guid;
            device.Name = element.DeviceName;
            device.ChannelsAmount = element.ChannelsNumber;
            device.DeviceType = element.DeviceType;
            device.CommunicationWay = element.CommunicationWay;
            device.DeviceState = element.DeviceState;
            device.IsEnabled = element.IsEnabled;
            device.IsVirtual = element.IsVirtual;
            device.SerialNumber = element.DeviceSerialNumber;
            device.ManufacturerGuid = element.ManufacturerGuid;
            device.ModelGuid = element.DeviceModelGuid;
            device.Model = element.DeviceModel;
            device.Name = element.DeviceName;
            try {
                (_a = element.AvailableTasks) === null || _a === void 0 ? void 0 : _a.forEach(function (task) {
                    var typeInfo = new DeviceTaskTypeInfo();
                    if (device.CommunicationWay == CommunicationWay.OneWay) {
                        switch (task) {
                            case "IBlindPosition":
                                typeInfo.InterfaceType = "IBlindPositionSimple";
                                break;
                        }
                    }
                    else
                        switch (task) {
                            case "IGatePosition":
                                typeInfo.InterfaceType = "IGatePulse";
                                break;
                            case "IGatewayPosition":
                                typeInfo.InterfaceType = "IGatewayPulse";
                                break;
                            default:
                                typeInfo.InterfaceType = task;
                                break;
                        }
                    device.AvailableTaskTypes.push(typeInfo);
                });
                (_b = element.AvailableResponses) === null || _b === void 0 ? void 0 : _b.forEach(function (response) {
                    var typeInfo = new DeviceResponseTypeInfo();
                    typeInfo.InterfaceType = response;
                    device.AvailableResponseTypes.push(typeInfo);
                });
                (_c = element.ChannelsConfiguration) === null || _c === void 0 ? void 0 : _c.forEach(function (configuration) {
                    var _a, _b, _c;
                    try {
                        var ch = new DeviceChannel();
                        device.Channels.push(ch);
                        ch.Number = configuration.Channel;
                        ch.Name = configuration.ChannelName;
                        ch.ChannelGroups = configuration.GroupsGuids;
                        ch.IconName = configuration.IconName;
                        ch.IsHidden = configuration.Hidden;
                        (_a = configuration.AvailableResponses) === null || _a === void 0 ? void 0 : _a.forEach(function (response) {
                            var typeInfo = new DeviceResponseTypeInfo();
                            typeInfo.InterfaceType = response;
                            ch.AvailableResponseTypes.push(typeInfo);
                        });
                        (_b = configuration.AvailableTasks) === null || _b === void 0 ? void 0 : _b.forEach(function (task) {
                            var typeInfo = new DeviceTaskTypeInfo();
                            typeInfo.InterfaceType = task;
                            ch.AvailableTaskTypes.push(typeInfo);
                        });
                    }
                    catch (ex) {
                        (_c = DependencyContainer.Log) === null || _c === void 0 ? void 0 : _c.Error(ex);
                    }
                });
            }
            catch (ex) {
                (_d = DependencyContainer.Log) === null || _d === void 0 ? void 0 : _d.Error(ex);
            }
            devices.push(device);
        });
        this._devices = devices;
        return devices;
    };
    DevicesService.prototype.GetDevicesAsync = function () {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new GetDevicesListRequest(), 5000, true))];
                    case 1:
                        result = _c.sent();
                        if (result == null)
                            return [2, []];
                        if (result.Status == Status.OK && result.Data != null)
                            return [2, this.MapApiDevices(result.Data)];
                        else {
                            (_b = DependencyContainer.Log) === null || _b === void 0 ? void 0 : _b.Error(DevicesService, "Failed to get devices. ".concat(result.Status, " ").concat(result.Data));
                            return [2, []];
                        }
                        return [2];
                }
            });
        });
    };
    DevicesService.prototype.GetDevice = function (guid) {
        return this._devices.find(function (a) { return a.Guid === guid; });
    };
    DevicesService.prototype.FindDevicesAsync = function () {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new SearchForDevicesRequest(), 35000, false))];
                    case 1:
                        _b.sent();
                        return [2];
                }
            });
        });
    };
    DevicesService.prototype.StopSearchingForDevices = function () {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new StopSearchingForDevicesRequest(), 5000, false))];
                    case 1:
                        _b.sent();
                        return [2];
                }
            });
        });
    };
    DevicesService.prototype.RegisterDeviceAsync = function (device) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var req, res;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        req = new DevicePairRequest();
                        req.Data = device.Guid;
                        return [4, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(req, 10000, false))];
                    case 1:
                        res = _b.sent();
                        if ((res === null || res === void 0 ? void 0 : res.Status) == Status.OK) {
                            this._devices.push(device);
                            this._onDeviceRegisteredEvent.Invoke(device);
                            return [2, DeviceTaskExecutionResult.Executed];
                        }
                        else
                            return [2, DeviceTaskExecutionResult.Failed];
                        return [2];
                }
            });
        });
    };
    DevicesService.prototype.RemoveDeviceAsync = function (device) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var req, res;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        req = new DeviceUnpairRequest();
                        req.Data = device.Guid;
                        return [4, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(req, 35000, false))];
                    case 1:
                        res = _b.sent();
                        if ((res === null || res === void 0 ? void 0 : res.Status) == Status.OK) {
                            this._devices = this._devices.where(function (a) { return a.Guid == device.Guid; }).toArray();
                            this._onDeviceRemovedEvent.Invoke(device);
                            return [2, DeviceTaskExecutionResult.Executed];
                        }
                        else
                            return [2, DeviceTaskExecutionResult.Failed];
                        return [2];
                }
            });
        });
    };
    DevicesService.prototype.ExecuteDeviceTaskAsync = function (device, task) {
        var _a, _b, _c, _d;
        return __awaiter(this, void 0, void 0, function () {
            var t, tsk, ts, fp, result, ex_1;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        t = new DeviceTaskInfo();
                        tsk = task;
                        switch (tsk.FeatureType) {
                            case DeviceControlFeature.SetTemperature:
                                t.Data = task.Temperature;
                                break;
                            case DeviceControlFeature.SetLightBrightness:
                                t.Data = task.Brightness;
                                break;
                            case DeviceControlFeature.SetLightColor:
                                t = new LightColorTaskInfo();
                                ts = task;
                                t.R = ts.R;
                                t.G = ts.G;
                                t.B = ts.B;
                                break;
                            case DeviceControlFeature.SetLightTemperature:
                                t.Data = task.Temperature;
                                break;
                            case DeviceControlFeature.SetBlindPosition:
                                switch (task.Action) {
                                    case BlindActionEnum.Open:
                                        t.Data = 101;
                                        break;
                                    case BlindActionEnum.Close:
                                        t.Data = 102;
                                        break;
                                    case BlindActionEnum.Stop:
                                        t.Data = 103;
                                        break;
                                    case BlindActionEnum.Percentage:
                                        t.Data = task.Position;
                                        break;
                                }
                                break;
                            case DeviceControlFeature.SetLightBrightnessDynamicly:
                                t.Data = task.Brightness;
                                break;
                            case DeviceControlFeature.SetBlindOpenCloseTime:
                                t.Data = task.Data;
                                break;
                            case DeviceControlFeature.SetBlindMicroventilation:
                                t.Data = task.Position;
                                break;
                            case DeviceControlFeature.SetFacadePositionAndTilt:
                                t = new FacadePositionTaskInfo();
                                fp = task;
                                t.FacadeAction = fp.FacadeAction;
                                t.Tilt = fp.Tilt;
                                t.Position = fp.Position;
                                break;
                        }
                        t.Channel = task.Channel;
                        t.DeviceGuid = task.DeviceGuid;
                        t.ControlFeature = tsk.FeatureType;
                        _e.label = 1;
                    case 1:
                        _e.trys.push([1, 3, , 4]);
                        return [4, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new ExecuteDeviceTaskRequest(t), 15000, false))];
                    case 2:
                        result = _e.sent();
                        switch (result === null || result === void 0 ? void 0 : result.Status) {
                            case Status.OK:
                                return [2, DeviceTaskExecutionResult.Executed];
                            case Status.WrongData:
                                switch (result.Data) {
                                    case "DeviceNotFound":
                                        return [2, DeviceTaskExecutionResult.DeviceNotFound];
                                    case "DeviceResponseTimeout":
                                        return [2, DeviceTaskExecutionResult.DeviceResponseTimeout];
                                }
                                break;
                            case Status.Error:
                                (_b = DependencyContainer.Log) === null || _b === void 0 ? void 0 : _b.Error("Unknown error occured when trying to execute task on device. Error code: ".concat(result.Data));
                                return [2, DeviceTaskExecutionResult.Failed];
                        }
                        return [3, 4];
                    case 3:
                        ex_1 = _e.sent();
                        if (ex_1.message.includes("timeout")) {
                            (_c = DependencyContainer.Log) === null || _c === void 0 ? void 0 : _c.Error("Failed to get controller response in time.\n".concat(ex_1));
                            return [2, DeviceTaskExecutionResult.ControllerResponseTimeout];
                        }
                        else {
                            (_d = DependencyContainer.Log) === null || _d === void 0 ? void 0 : _d.Error("Unknown error occured when trying to execute task on device.\n".concat(ex_1));
                            return [2, DeviceTaskExecutionResult.Failed];
                        }
                        return [3, 4];
                    case 4: return [2, DeviceTaskExecutionResult.Unknown];
                }
            });
        });
    };
    return DevicesService;
}());
export { DevicesService };
var DeviceObject = (function () {
    function DeviceObject() {
        this.Guid = "";
        this.CloudGuid = "";
        this.DeviceSerialNumber = "";
        this.DeviceModelGuid = "";
        this.ProtocolGuid = "";
        this.DeviceName = "";
        this.DeviceModel = "";
        this.ManufacturerGuid = "";
        this.ChannelsNumber = 0;
        this.IsVirtual = false;
        this.IsEnabled = false;
        this.DeviceState = DeviceState.Working;
        this.CommunicationWay = CommunicationWay.OneWay;
        this.DeviceType = DeviceType.Unknown;
        this.ChannelsConfiguration = [];
        this.Groups = [];
        this.AvailableTasks = [];
        this.AvailableResponses = [];
    }
    return DeviceObject;
}());
var DeviceGroupObject = (function () {
    function DeviceGroupObject() {
        this.Guid = "";
        this.Name = "";
    }
    return DeviceGroupObject;
}());
var ChannelConfigurationObject = (function () {
    function ChannelConfigurationObject() {
        this.Channel = 0;
        this.ChannelName = "";
        this.Configuration = ChannelConfigurations.Default;
        this.IconName = "";
        this.GroupsGuids = [];
        this.Hidden = false;
        this.AvailableTasks = [];
        this.AvailableResponses = [];
    }
    return ChannelConfigurationObject;
}());
var GetDevicesListRequest = (function (_super) {
    __extends(GetDevicesListRequest, _super);
    function GetDevicesListRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/list";
        _this.Method = Method.Get;
        return _this;
    }
    return GetDevicesListRequest;
}(DataFrame));
var SyncDevicesStatesRequest = (function (_super) {
    __extends(SyncDevicesStatesRequest, _super);
    function SyncDevicesStatesRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/channels/states";
        _this.Method = Method.Get;
        return _this;
    }
    return SyncDevicesStatesRequest;
}(DataFrame));
var SearchForDevicesRequest = (function (_super) {
    __extends(SearchForDevicesRequest, _super);
    function SearchForDevicesRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/search";
        _this.Method = Method.Post;
        return _this;
    }
    return SearchForDevicesRequest;
}(DataFrame));
var StopSearchingForDevicesRequest = (function (_super) {
    __extends(StopSearchingForDevicesRequest, _super);
    function StopSearchingForDevicesRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/search/stop";
        _this.Method = Method.Post;
        return _this;
    }
    return StopSearchingForDevicesRequest;
}(DataFrame));
var GetFoundDevicesRequest = (function (_super) {
    __extends(GetFoundDevicesRequest, _super);
    function GetFoundDevicesRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/found/list";
        _this.Method = Method.Get;
        return _this;
    }
    return GetFoundDevicesRequest;
}(DataFrame));
var DeviceStateChangedObject = (function () {
    function DeviceStateChangedObject() {
        this.DeviceGuid = "";
        this.state = new DeviceStateObject();
        this.Type = 0;
        this.DataType = "";
    }
    return DeviceStateChangedObject;
}());
export { DeviceStateChangedObject };
var DeviceStateObject = (function () {
    function DeviceStateObject() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
    }
    return DeviceStateObject;
}());
export { DeviceStateObject };
var GetRunningDevicesTasksRequest = (function (_super) {
    __extends(GetRunningDevicesTasksRequest, _super);
    function GetRunningDevicesTasksRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/tasks";
        _this.Method = Method.Get;
        return _this;
    }
    return GetRunningDevicesTasksRequest;
}(DataFrame));
var DevicePairRequest = (function (_super) {
    __extends(DevicePairRequest, _super);
    function DevicePairRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/device/pair";
        _this.Method = Method.Put;
        return _this;
    }
    return DevicePairRequest;
}(DataFrame));
var DeviceUnpairRequest = (function (_super) {
    __extends(DeviceUnpairRequest, _super);
    function DeviceUnpairRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/device/unpair";
        _this.Method = Method.Put;
        return _this;
    }
    return DeviceUnpairRequest;
}(DataFrame));
var ExecuteDeviceTaskRequest = (function (_super) {
    __extends(ExecuteDeviceTaskRequest, _super);
    function ExecuteDeviceTaskRequest(task) {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/device/control";
        _this.Method = Method.Post;
        _this.Data = new DeviceTaskInfo();
        return _this;
    }
    return ExecuteDeviceTaskRequest;
}(DataFrame));
var DeviceTaskInfo = (function () {
    function DeviceTaskInfo() {
        this.DeviceGuid = "";
        this.Channel = 0;
        this.ControlFeature = DeviceControlFeature.GetState;
    }
    return DeviceTaskInfo;
}());
var LightColorTaskInfo = (function (_super) {
    __extends(LightColorTaskInfo, _super);
    function LightColorTaskInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.R = 0;
        _this.G = 0;
        _this.B = 0;
        return _this;
    }
    return LightColorTaskInfo;
}(DeviceTaskInfo));
var FacadePositionTaskInfo = (function (_super) {
    __extends(FacadePositionTaskInfo, _super);
    function FacadePositionTaskInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.FacadeAction = FacadeActionEnum.Stop;
        _this.Tilt = 0;
        _this.Position = 0;
        return _this;
    }
    return FacadePositionTaskInfo;
}(DeviceTaskInfo));
//# sourceMappingURL=DevicesService.js.map