var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { DeviceTaskType } from "../IDevice";
import { DeviceControlFeature } from "../IDeviceTask";
import { DeviceTask } from "./DeviceTask";
var SetTemperature = (function (_super) {
    __extends(SetTemperature, _super);
    function SetTemperature() {
        var _this = _super.call(this) || this;
        _this.Temperature = 0;
        _this.FeatureType = DeviceControlFeature.SetTemperature;
        _this.TaskType = DeviceTaskType.SetTemperature;
        return _this;
    }
    return SetTemperature;
}(DeviceTask));
export { SetTemperature };
var TurnOff = (function (_super) {
    __extends(TurnOff, _super);
    function TurnOff() {
        var _this = _super.call(this) || this;
        _this.FeatureType = DeviceControlFeature.TurnOff;
        _this.TaskType = DeviceTaskType.TurnOff;
        return _this;
    }
    return TurnOff;
}(DeviceTask));
export { TurnOff };
var TurnOn = (function (_super) {
    __extends(TurnOn, _super);
    function TurnOn() {
        var _this = _super.call(this) || this;
        _this.FeatureType = DeviceControlFeature.TurnOn;
        _this.TaskType = DeviceTaskType.TurnOn;
        return _this;
    }
    return TurnOn;
}(DeviceTask));
export { TurnOn };
var SetLightBrightness = (function (_super) {
    __extends(SetLightBrightness, _super);
    function SetLightBrightness() {
        var _this = _super.call(this) || this;
        _this.Brightness = 0;
        _this.FeatureType = DeviceControlFeature.SetLightBrightness;
        _this.TaskType = DeviceTaskType.SetLightBrightness;
        return _this;
    }
    return SetLightBrightness;
}(DeviceTask));
export { SetLightBrightness };
var ToggleState = (function (_super) {
    __extends(ToggleState, _super);
    function ToggleState() {
        var _this = _super.call(this) || this;
        _this.FeatureType = DeviceControlFeature.ToggleState;
        _this.TaskType = DeviceTaskType.TogleState;
        return _this;
    }
    return ToggleState;
}(DeviceTask));
export { ToggleState };
var SetLightColor = (function (_super) {
    __extends(SetLightColor, _super);
    function SetLightColor() {
        var _this = _super.call(this) || this;
        _this.R = 0;
        _this.G = 0;
        _this.B = 0;
        _this.FeatureType = DeviceControlFeature.SetLightColor;
        _this.TaskType = DeviceTaskType.SetLightColor;
        return _this;
    }
    return SetLightColor;
}(DeviceTask));
export { SetLightColor };
var SetLightTemperature = (function (_super) {
    __extends(SetLightTemperature, _super);
    function SetLightTemperature() {
        var _this = _super.call(this) || this;
        _this.Temperature = 0;
        _this.FeatureType = DeviceControlFeature.SetLightTemperature;
        _this.TaskType = DeviceTaskType.SetLightTemperature;
        return _this;
    }
    return SetLightTemperature;
}(DeviceTask));
export { SetLightTemperature };
var SetBlindPosition = (function (_super) {
    __extends(SetBlindPosition, _super);
    function SetBlindPosition() {
        var _this = _super.call(this) || this;
        _this.Action = BlindActionEnum.Stop;
        _this.Position = 0;
        _this.FeatureType = DeviceControlFeature.SetBlindPosition;
        _this.TaskType = DeviceTaskType.SetBlindPosition;
        return _this;
    }
    return SetBlindPosition;
}(DeviceTask));
export { SetBlindPosition };
export var BlindActionEnum;
(function (BlindActionEnum) {
    BlindActionEnum[BlindActionEnum["Open"] = 0] = "Open";
    BlindActionEnum[BlindActionEnum["Close"] = 1] = "Close";
    BlindActionEnum[BlindActionEnum["Stop"] = 2] = "Stop";
    BlindActionEnum[BlindActionEnum["Percentage"] = 3] = "Percentage";
})(BlindActionEnum || (BlindActionEnum = {}));
var SetBlindPositionSimple = (function (_super) {
    __extends(SetBlindPositionSimple, _super);
    function SetBlindPositionSimple() {
        var _this = _super.call(this) || this;
        _this.Action = BlindActionSimpleEnum.Stop;
        _this.Position = 0;
        _this.FeatureType = DeviceControlFeature.SetBlindPosition;
        _this.TaskType = DeviceTaskType.SetBlindPositionSimple;
        return _this;
    }
    return SetBlindPositionSimple;
}(DeviceTask));
export { SetBlindPositionSimple };
export var BlindActionSimpleEnum;
(function (BlindActionSimpleEnum) {
    BlindActionSimpleEnum[BlindActionSimpleEnum["Open"] = 0] = "Open";
    BlindActionSimpleEnum[BlindActionSimpleEnum["Close"] = 1] = "Close";
    BlindActionSimpleEnum[BlindActionSimpleEnum["Stop"] = 2] = "Stop";
})(BlindActionSimpleEnum || (BlindActionSimpleEnum = {}));
var SetLightBrightnessDynamicly = (function (_super) {
    __extends(SetLightBrightnessDynamicly, _super);
    function SetLightBrightnessDynamicly() {
        var _this = _super.call(this) || this;
        _this.Brightness = 0;
        _this.FeatureType = DeviceControlFeature.SetLightBrightnessDynamicly;
        _this.TaskType = DeviceTaskType.SetLightBrightnessDynamicly;
        return _this;
    }
    return SetLightBrightnessDynamicly;
}(DeviceTask));
export { SetLightBrightnessDynamicly };
var IdentifyDevice = (function (_super) {
    __extends(IdentifyDevice, _super);
    function IdentifyDevice() {
        var _this = _super.call(this) || this;
        _this.FeatureType = DeviceControlFeature.IdentifyDevice;
        _this.TaskType = DeviceTaskType.IdentifyDevice;
        return _this;
    }
    return IdentifyDevice;
}(DeviceTask));
export { IdentifyDevice };
var SetBlindOpenCloseTime = (function (_super) {
    __extends(SetBlindOpenCloseTime, _super);
    function SetBlindOpenCloseTime() {
        var _this = _super.call(this) || this;
        _this.Data = new BlindOpenCloseTimeData();
        _this.FeatureType = DeviceControlFeature.SetBlindOpenCloseTime;
        _this.TaskType = DeviceTaskType.SetBlindOpenCloseTime;
        return _this;
    }
    return SetBlindOpenCloseTime;
}(DeviceTask));
export { SetBlindOpenCloseTime };
var BlindOpenCloseTimeData = (function () {
    function BlindOpenCloseTimeData() {
        this.Channel = 0;
        this.CloseTime = 0;
        this.OpenTime = 0;
    }
    return BlindOpenCloseTimeData;
}());
export { BlindOpenCloseTimeData };
var GetDeviceState = (function (_super) {
    __extends(GetDeviceState, _super);
    function GetDeviceState() {
        var _this = _super.call(this) || this;
        _this.FeatureType = DeviceControlFeature.GetState;
        _this.TaskType = DeviceTaskType.GetChannelsState;
        return _this;
    }
    return GetDeviceState;
}(DeviceTask));
export { GetDeviceState };
var SetBlindMicroventilation = (function (_super) {
    __extends(SetBlindMicroventilation, _super);
    function SetBlindMicroventilation() {
        var _this = _super.call(this) || this;
        _this.Position = 0;
        _this.FeatureType = DeviceControlFeature.SetBlindMicroventilation;
        _this.TaskType = DeviceTaskType.SetBlindMicroventilation;
        return _this;
    }
    return SetBlindMicroventilation;
}(DeviceTask));
export { SetBlindMicroventilation };
var ChangeGatePositionPulse = (function (_super) {
    __extends(ChangeGatePositionPulse, _super);
    function ChangeGatePositionPulse() {
        var _this = _super.call(this) || this;
        _this.FeatureType = DeviceControlFeature.GatePulse;
        _this.TaskType = DeviceTaskType.ChangeGatewayPositionPulse;
        return _this;
    }
    return ChangeGatePositionPulse;
}(DeviceTask));
export { ChangeGatePositionPulse };
var ChangeGatewayPositionPulse = (function (_super) {
    __extends(ChangeGatewayPositionPulse, _super);
    function ChangeGatewayPositionPulse() {
        var _this = _super.call(this) || this;
        _this.FeatureType = DeviceControlFeature.GatewayPulse;
        _this.TaskType = DeviceTaskType.ChangeGatewayPositionPulse;
        return _this;
    }
    return ChangeGatewayPositionPulse;
}(DeviceTask));
export { ChangeGatewayPositionPulse };
var SetFacadePosition = (function (_super) {
    __extends(SetFacadePosition, _super);
    function SetFacadePosition() {
        var _this = _super.call(this) || this;
        _this.FacadeAction = FacadeActionEnum.Stop;
        _this.Tilt = 0;
        _this.Position = 0;
        _this.FeatureType = DeviceControlFeature.SetFacadePositionAndTilt;
        _this.TaskType = DeviceTaskType.SetFacadePosition;
        return _this;
    }
    return SetFacadePosition;
}(DeviceTask));
export { SetFacadePosition };
export var FacadeActionEnum;
(function (FacadeActionEnum) {
    FacadeActionEnum[FacadeActionEnum["Open"] = 0] = "Open";
    FacadeActionEnum[FacadeActionEnum["Close"] = 1] = "Close";
    FacadeActionEnum[FacadeActionEnum["Stop"] = 2] = "Stop";
    FacadeActionEnum[FacadeActionEnum["Percentage"] = 3] = "Percentage";
    FacadeActionEnum[FacadeActionEnum["Tilt"] = 4] = "Tilt";
    FacadeActionEnum[FacadeActionEnum["TiltAndPercentage"] = 5] = "TiltAndPercentage";
})(FacadeActionEnum || (FacadeActionEnum = {}));
//# sourceMappingURL=Tasks.js.map